Index: src/backend/rewrite/rewriteRemove.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/rewrite/rewriteRemove.c,v
retrieving revision 1.49
diff -c -r1.49 rewriteRemove.c
*** src/backend/rewrite/rewriteRemove.c	2002/04/27 03:45:03	1.49
--- src/backend/rewrite/rewriteRemove.c	2002/06/15 16:38:53
***************
*** 17,32 ****
  #include "access/genam.h"
  #include "access/heapam.h"
  #include "catalog/catname.h"
  #include "catalog/indexing.h"
  #include "catalog/pg_rewrite.h"
- #include "commands/comment.h"
  #include "miscadmin.h"
  #include "rewrite/rewriteRemove.h"
  #include "rewrite/rewriteSupport.h"
  #include "utils/acl.h"
  #include "utils/fmgroids.h"
  #include "utils/syscache.h"
  
  
  /*
   * RemoveRewriteRule
--- 17,34 ----
  #include "access/genam.h"
  #include "access/heapam.h"
  #include "catalog/catname.h"
+ #include "catalog/pg_depend.h"
  #include "catalog/indexing.h"
  #include "catalog/pg_rewrite.h"
  #include "miscadmin.h"
  #include "rewrite/rewriteRemove.h"
  #include "rewrite/rewriteSupport.h"
+ #include "utils/builtins.h"
  #include "utils/acl.h"
  #include "utils/fmgroids.h"
  #include "utils/syscache.h"
  
+ void RemoveRewriteRuleByTuple(Relation rewriteRelation, HeapTuple tuple, bool force, int behavior);
  
  /*
   * RemoveRewriteRule
***************
*** 34,48 ****
   * Delete a rule given its name.
   */
  void
! RemoveRewriteRule(Oid owningRel, const char *ruleName)
  {
  	Relation	RewriteRelation;
- 	Relation	event_relation;
  	HeapTuple	tuple;
- 	Oid			ruleId;
- 	Oid			eventRelationOid;
- 	bool		hasMoreRules;
- 	AclResult	aclresult;
  
  	/*
  	 * Open the pg_rewrite relation.
--- 36,45 ----
   * Delete a rule given its name.
   */
  void
! RemoveRewriteRule(Oid owningRel, const char *ruleName, int behavior)
  {
  	Relation	RewriteRelation;
  	HeapTuple	tuple;
  
  	/*
  	 * Open the pg_rewrite relation.
***************
*** 67,75 ****
  	 * Save the OID of the rule (i.e. the tuple's OID) and the event
  	 * relation's OID
  	 */
  	ruleId = tuple->t_data->t_oid;
  	eventRelationOid = ((Form_pg_rewrite) GETSTRUCT(tuple))->ev_class;
- 	Assert(eventRelationOid == owningRel);
  
  	/*
  	 * We had better grab AccessExclusiveLock so that we know no other
--- 64,133 ----
  	 * Save the OID of the rule (i.e. the tuple's OID) and the event
  	 * relation's OID
  	 */
+ 	Assert(((Form_pg_rewrite) GETSTRUCT(tuple))->ev_class == owningRel);
+ 
+ 	RemoveRewriteRuleByTuple(RewriteRelation, tuple, false, behavior);
+ 
+ 	heap_freetuple(tuple);
+ 
+ 	heap_close(RewriteRelation, RowExclusiveLock);
+ }
+ 
+ void
+ RemoveRewriteRuleById(Oid ruleId, int behavior)
+ {
+ 	Relation	RewriteRelation;
+ 	SysScanDesc scanDesc;
+ 	ScanKeyData scanKeyData;
+ 	HeapTuple	tuple;
+ 	
+ 	/*
+ 	 * Open the pg_rewrite relation.
+ 	 */
+ 	RewriteRelation = heap_openr(RewriteRelationName, RowExclusiveLock);
+ 
+ 	/*
+ 	 * Find the tuple for the target rule.
+ 	 */
+ 	ScanKeyEntryInitialize(&scanKeyData,
+ 						   0,
+ 						   ObjectIdAttributeNumber,
+ 						   F_OIDEQ,
+ 						   ObjectIdGetDatum(ruleId));
+ 
+ 	scanDesc = systable_beginscan(RewriteRelation, 0, false,
+ 								  SnapshotNow, 1, &scanKeyData);
+ 
+ 	/* Exactly 1 tuple should be found */
+ 	tuple = systable_getnext(scanDesc);
+ 	if (!HeapTupleIsValid(tuple))
+ 		elog(ERROR, "RemoveRewriteRuleById: Could not find RuleId %d", ruleId);
+ 
+ 	RemoveRewriteRuleByTuple(RewriteRelation, tuple, true, behavior);
+ 
+ 	systable_endscan(scanDesc);
+ 
+ 	heap_close(RewriteRelation, RowExclusiveLock);
+ }
+ 
+ /*
+  * RemoveRewriteRuleByTuple
+  *
+  * If force is true then the fact that the rule is owned by a view is ignored
+  * by the system.  It will remove it anyway.
+  */
+ void
+ RemoveRewriteRuleByTuple(Relation rewriteRelation, HeapTuple tuple, bool force, int behavior)
+ {
+ 
+ 	Relation	event_relation;
+ 	bool		hasMoreRules;
+ 	Oid			ruleId;
+ 	Oid			eventRelationOid;
+ 	AclResult	aclresult;
+ 
  	ruleId = tuple->t_data->t_oid;
  	eventRelationOid = ((Form_pg_rewrite) GETSTRUCT(tuple))->ev_class;
  
  	/*
  	 * We had better grab AccessExclusiveLock so that we know no other
***************
*** 87,113 ****
  		aclcheck_error(aclresult, RelationGetRelationName(event_relation));
  
  	/* do not allow the removal of a view's SELECT rule */
! 	if (event_relation->rd_rel->relkind == RELKIND_VIEW &&
  		((Form_pg_rewrite) GETSTRUCT(tuple))->ev_type == '1')
! 		elog(ERROR, "Cannot remove a view's SELECT rule");
  
  	hasMoreRules = event_relation->rd_rules != NULL &&
  		event_relation->rd_rules->numLocks > 1;
  
! 	/*
! 	 * Delete any comments associated with this rule
! 	 */
! 	DeleteComments(ruleId, RelationGetRelid(RewriteRelation));
  
  	/*
  	 * Now delete the pg_rewrite tuple for the rule
  	 */
! 	simple_heap_delete(RewriteRelation, &tuple->t_self);
  
- 	heap_freetuple(tuple);
- 
- 	heap_close(RewriteRelation, RowExclusiveLock);
- 
  	/*
  	 * Set pg_class 'relhasrules' field correctly for event relation.
  	 *
--- 145,165 ----
  		aclcheck_error(aclresult, RelationGetRelationName(event_relation));
  
  	/* do not allow the removal of a view's SELECT rule */
! 	if (force == false && event_relation->rd_rel->relkind == RELKIND_VIEW &&
  		((Form_pg_rewrite) GETSTRUCT(tuple))->ev_type == '1')
! 		elog(ERROR, "RemoveRewriteRuleByTuple: Cannot remove a view's SELECT rule");
  
  	hasMoreRules = event_relation->rd_rules != NULL &&
  		event_relation->rd_rules->numLocks > 1;
  
! 	/* Deal with dependencies */
! 	dependDeleteTuple(tuple, rewriteRelation, behavior);
  
  	/*
  	 * Now delete the pg_rewrite tuple for the rule
  	 */
! 	simple_heap_delete(rewriteRelation, &tuple->t_self);
  
  	/*
  	 * Set pg_class 'relhasrules' field correctly for event relation.
  	 *
***************
*** 119,168 ****
  
  	/* Close rel, but keep lock till commit... */
  	heap_close(event_relation, NoLock);
- }
- 
- /*
-  * RelationRemoveRules -
-  *	  removes all rules associated with the relation when the relation is
-  *	  being removed.
-  */
- void
- RelationRemoveRules(Oid relid)
- {
- 	Relation	RewriteRelation;
- 	SysScanDesc scanDesc;
- 	ScanKeyData scanKeyData;
- 	HeapTuple	tuple;
- 
- 	/*
- 	 * Open the pg_rewrite relation.
- 	 */
- 	RewriteRelation = heap_openr(RewriteRelationName, RowExclusiveLock);
- 
- 	/*
- 	 * Scan pg_rewrite for all the tuples that have the same ev_class
- 	 * as relid (the relation to be removed).
- 	 */
- 	ScanKeyEntryInitialize(&scanKeyData,
- 						   0,
- 						   Anum_pg_rewrite_ev_class,
- 						   F_OIDEQ,
- 						   ObjectIdGetDatum(relid));
- 
- 	scanDesc = systable_beginscan(RewriteRelation,
- 								  RewriteRelRulenameIndex,
- 								  true, SnapshotNow,
- 								  1, &scanKeyData);
- 
- 	while (HeapTupleIsValid(tuple = systable_getnext(scanDesc)))
- 	{
- 		/* Delete any comments associated with this rule */
- 		DeleteComments(tuple->t_data->t_oid, RelationGetRelid(RewriteRelation));
- 
- 		simple_heap_delete(RewriteRelation, &tuple->t_self);
- 	}
- 
- 	systable_endscan(scanDesc);
- 
- 	heap_close(RewriteRelation, RowExclusiveLock);
  }
--- 171,174 ----
Index: src/backend/tcop/utility.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/tcop/utility.c,v
retrieving revision 1.156
diff -c -r1.156 utility.c
*** src/backend/tcop/utility.c	2002/05/21 22:18:08	1.156
--- src/backend/tcop/utility.c	2002/06/15 16:38:58
***************
*** 289,318 ****
  						case DROP_TABLE:
  							rel = makeRangeVarFromNameList(names);
  							CheckDropPermissions(rel, RELKIND_RELATION);
! 							RemoveRelation(rel);
  							break;
  
  						case DROP_SEQUENCE:
  							rel = makeRangeVarFromNameList(names);
  							CheckDropPermissions(rel, RELKIND_SEQUENCE);
! 							RemoveRelation(rel);
  							break;
  
  						case DROP_VIEW:
  							rel = makeRangeVarFromNameList(names);
  							CheckDropPermissions(rel, RELKIND_VIEW);
! 							RemoveView(rel);
  							break;
  
  						case DROP_INDEX:
  							rel = makeRangeVarFromNameList(names);
  							CheckDropPermissions(rel, RELKIND_INDEX);
! 							RemoveIndex(rel);
  							break;
  
  						case DROP_TYPE:
  							/* RemoveType does its own permissions checks */
! 							RemoveType(names);
  							break;
  
  						case DROP_DOMAIN:
--- 289,318 ----
  						case DROP_TABLE:
  							rel = makeRangeVarFromNameList(names);
  							CheckDropPermissions(rel, RELKIND_RELATION);
! 							RemoveRelation(rel, stmt->behavior);
  							break;
  
  						case DROP_SEQUENCE:
  							rel = makeRangeVarFromNameList(names);
  							CheckDropPermissions(rel, RELKIND_SEQUENCE);
! 							RemoveRelation(rel, stmt->behavior);
  							break;
  
  						case DROP_VIEW:
  							rel = makeRangeVarFromNameList(names);
  							CheckDropPermissions(rel, RELKIND_VIEW);
! 							RemoveView(rel, stmt->behavior);
  							break;
  
  						case DROP_INDEX:
  							rel = makeRangeVarFromNameList(names);
  							CheckDropPermissions(rel, RELKIND_INDEX);
! 							RemoveIndex(rel, stmt->behavior);
  							break;
  
  						case DROP_TYPE:
  							/* RemoveType does its own permissions checks */
! 							RemoveType(names, stmt->behavior);
  							break;
  
  						case DROP_DOMAIN:
***************
*** 605,611 ****
  			{
  				RemoveAggrStmt *stmt = (RemoveAggrStmt *) parsetree;
  
! 				RemoveAggregate(stmt->aggname, stmt->aggtype);
  			}
  			break;
  
--- 605,611 ----
  			{
  				RemoveAggrStmt *stmt = (RemoveAggrStmt *) parsetree;
  
! 				RemoveAggregate(stmt->aggname, stmt->aggtype, stmt->behavior);
  			}
  			break;
  
***************
*** 613,619 ****
  			{
  				RemoveFuncStmt *stmt = (RemoveFuncStmt *) parsetree;
  
! 				RemoveFunction(stmt->funcname, stmt->args);
  			}
  			break;
  
--- 613,619 ----
  			{
  				RemoveFuncStmt *stmt = (RemoveFuncStmt *) parsetree;
  
! 				RemoveFunction(stmt->funcname, stmt->args, stmt->behavior);
  			}
  			break;
  
***************
*** 623,629 ****
  				TypeName   *typenode1 = (TypeName *) lfirst(stmt->args);
  				TypeName   *typenode2 = (TypeName *) lsecond(stmt->args);
  
! 				RemoveOperator(stmt->opname, typenode1, typenode2);
  			}
  			break;
  
--- 623,629 ----
  				TypeName   *typenode1 = (TypeName *) lfirst(stmt->args);
  				TypeName   *typenode2 = (TypeName *) lsecond(stmt->args);
  
! 				RemoveOperator(stmt->opname, typenode1, typenode2, stmt->behavior);
  			}
  			break;
  
***************
*** 751,761 ****
  				{
  					case DROP_RULE:
  						/* RemoveRewriteRule checks permissions */
! 						RemoveRewriteRule(relId, stmt->property);
  						break;
  					case DROP_TRIGGER:
  						/* DropTrigger checks permissions */
! 						DropTrigger(relId, stmt->property);
  						break;
  				}
  			}
--- 751,761 ----
  				{
  					case DROP_RULE:
  						/* RemoveRewriteRule checks permissions */
! 						RemoveRewriteRule(relId, stmt->property, stmt->behavior);
  						break;
  					case DROP_TRIGGER:
  						/* DropTrigger checks permissions */
! 						DropTrigger(relId, stmt->property, stmt->behavior);
  						break;
  				}
  			}
Index: src/backend/utils/adt/ruleutils.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/utils/adt/ruleutils.c,v
retrieving revision 1.108
diff -c -r1.108 ruleutils.c
*** src/backend/utils/adt/ruleutils.c	2002/06/13 03:40:49	1.108
--- src/backend/utils/adt/ruleutils.c	2002/06/15 16:39:01
***************
*** 40,48 ****
--- 40,53 ----
  #include <unistd.h>
  #include <fcntl.h>
  
+ #include "access/heapam.h"
+ #include "access/genam.h"
+ #include "catalog/catname.h"
  #include "catalog/heap.h"
  #include "catalog/index.h"
+ #include "catalog/indexing.h"
  #include "catalog/namespace.h"
+ #include "catalog/pg_constraint.h"
  #include "catalog/pg_index.h"
  #include "catalog/pg_opclass.h"
  #include "catalog/pg_operator.h"
***************
*** 59,64 ****
--- 64,71 ----
  #include "parser/parsetree.h"
  #include "rewrite/rewriteManip.h"
  #include "rewrite/rewriteSupport.h"
+ #include "utils/array.h"
+ #include "utils/fmgroids.h"
  #include "utils/lsyscache.h"
  
  
***************
*** 520,525 ****
--- 527,730 ----
  	PG_RETURN_TEXT_P(indexdef);
  }
  
+ /*
+  * pg_get_fkeydef
+  *
+  * Returns the definitition statement required to recreate the foreign
+  * key structure
+  */
+ Datum
+ pg_get_fkeydef(PG_FUNCTION_ARGS)
+ {
+ 	Oid				relId = PG_GETARG_OID(0);
+ 	Name			cname = PG_GETARG_NAME(1);
+ 	text		   *result;
+ 	StringInfoData	buf;
+ 	Relation		conDesc;
+ 	HeapTuple		tup;
+ 	Datum			val;
+ 	char		   *string = NULL;
+ 	SysScanDesc		rcscan;
+ 	ScanKeyData		skey[2];
+ 	int				i = 0;
+ 	int				len;
+ 	bool			isnull;
+ 	Form_pg_constraint	fkCon;
+ 
+ 	conDesc = heap_openr(ConstraintRelationName, RowExclusiveLock);
+ 
+ 	ScanKeyEntryInitialize(&skey[i++],
+ 						   0, Anum_pg_constraint_conrelid, F_OIDEQ,
+ 						   ObjectIdGetDatum(relId));
+ 
+ 	ScanKeyEntryInitialize(&skey[i++],
+ 						   0, Anum_pg_constraint_conname, F_NAMEEQ,
+ 						   NameGetDatum(cname));
+ 
+ 	rcscan = systable_beginscan(conDesc, ConstraintRelidNameIndex, true,
+ 								SnapshotNow,
+ 								i, skey);
+ 	tup = systable_getnext(rcscan);
+ 	if (!HeapTupleIsValid(tup))
+ 		elog(ERROR, "syscache lookup for foreign key %s failed on relation %u", NameStr(*cname), relId);
+ 
+ 	fkCon = (Form_pg_constraint) GETSTRUCT(tup);
+ 
+ 
+ 	/* We only deal in foreign key constraints */
+ 	if (fkCon->contype != CONSTRAINT_FOREIGN)
+ 		elog(ERROR, "pg_get_fkeydef: %s is not a foreign key constraint", NameStr(*cname));
+ 
+ 	/* Start off the statement */
+ 	initStringInfo(&buf);
+ 	appendStringInfo(&buf, "ALTER TABLE %s ADD CONSTRAINT %s FOREIGN KEY (",
+ 					 generate_relation_name(fkCon->conrelid),
+ 					 quote_identifier(NameStr(fkCon->conname)));
+ 
+ 	/* Fetch and build column list */
+ 	val = heap_getattr(tup, Anum_pg_constraint_conkey,
+ 					   RelationGetDescr(conDesc), &isnull);
+ 
+ 	if (isnull)
+ 		elog(ERROR, "get_pg_fkeydef: Null conkey array for constraint %s",
+ 			 		NameStr(*cname));
+ 	else
+ 	{
+ 		Datum	   *keys;
+ 		int			j;
+ 		int			nKeys;
+ 		deconstruct_array(DatumGetArrayTypeP(val),
+ 						  true, 2, 's',
+ 						  &keys, &nKeys);
+ 
+ 		for (j = 0; j < nKeys; j++)
+ 		{
+ 			char	   *colName;
+ 
+ 			colName	= get_attname(fkCon->conrelid,
+ 								  DatumGetInt16(keys[j]));
+ 
+ 			if (j == 0)
+ 				appendStringInfo(&buf, "%s",
+ 								 quote_identifier(colName));
+ 			else
+ 				appendStringInfo(&buf, ", %s",
+ 								 quote_identifier(colName));
+ 		}
+ 	}
+ 
+ 	appendStringInfo(&buf, ")");
+ 
+ 	/* Add Foreign relation and key attributes */
+ 	appendStringInfo(&buf, " REFERENCES %s(",
+ 					 generate_relation_name(fkCon->confrelid));
+ 
+ 	/* Fetch and build column list */
+ 	val = heap_getattr(tup, Anum_pg_constraint_confkey,
+ 					   RelationGetDescr(conDesc), &isnull);
+ 
+ 	if (isnull)
+ 		elog(ERROR, "get_pg_fkeydef: Null confkey array for constraint %s",
+ 			 		NameStr(*cname));
+ 	else
+ 	{
+ 		Datum	   *keys;
+ 		int			j;
+ 		int			nKeys;
+ 		deconstruct_array(DatumGetArrayTypeP(val),
+ 						  true, 2, 's',
+ 						  &keys, &nKeys);
+ 
+ 		for (j = 0; j < nKeys; j++)
+ 		{
+ 			char	   *colName;
+ 
+ 			colName	= get_attname(fkCon->confrelid,
+ 								  DatumGetInt16(keys[j]));
+ 
+ 			if (j == 0)
+ 				appendStringInfo(&buf, "%s",
+ 								 quote_identifier(colName));
+ 			else
+ 				appendStringInfo(&buf, ", %s",
+ 								 quote_identifier(colName));
+ 		}
+ 	}
+ 
+ 
+ 
+ 	appendStringInfo(&buf, ")");
+ 
+ 	/* Add match type */
+ 	switch (fkCon->confmatchtype)
+ 	{
+ 		case 'p':
+ 			string = " MATCH PARTIAL";
+ 			break;
+ 		case 'f':
+ 			string = " MATCH FULL";
+ 			break;
+ 		default:
+ 			string = "";
+ 			break;
+ 	}
+ 	appendStringInfo(&buf, "%s", string);
+ 
+ 	/* Add ON UPDATE and ON DELETE clause */
+ 	switch (fkCon->confupdtype)
+ 	{
+ 		case 'r':
+ 			string = "RESTRICT";
+ 			break;
+ 		case 'c':
+ 			string = "CASCADE";
+ 			break;
+ 		case 'n':
+ 			string = "SET NULL";
+ 			break;
+ 		case 'd':
+ 			string = "SET DEFAULT";
+ 			break;
+ 		case 'a':
+ 			string = "NO ACTION";
+ 			break;
+ 	}
+ 	appendStringInfo(&buf, " ON UPDATE %s",
+ 					 string);
+ 
+ 	switch (fkCon->confdeltype)
+ 	{
+ 		case 'r':
+ 			string = "RESTRICT";
+ 			break;
+ 		case 'c':
+ 			string = "CASCADE";
+ 			break;
+ 		case 'n':
+ 			string = "SET NULL";
+ 			break;
+ 		case 'd':
+ 			string = "SET DEFAULT";
+ 			break;
+ 		case 'a':
+ 			string = "NO ACTION";
+ 			break;
+ 	}
+ 	appendStringInfo(&buf, " ON DELETE %s",
+ 					 string);
+ 
+ 	/* Cleanup */
+ 	systable_endscan(rcscan);
+ 	heap_close(conDesc, RowExclusiveLock);
+ 
+ 	/* Record the results */
+ 	len = buf.len + VARHDRSZ;
+ 	result = (text *) palloc(len);
+ 	VARATT_SIZEP(result) = len;
+ 	memcpy(VARDATA(result), buf.data, buf.len);
+ 
+ 	PG_RETURN_TEXT_P(result);
+ }
  
  /* ----------
   * get_expr			- Decompile an expression tree
Index: src/backend/utils/cache/relcache.c
===================================================================
RCS file: /projects/cvsroot/pgsql/src/backend/utils/cache/relcache.c,v
retrieving revision 1.164
diff -c -r1.164 relcache.c
*** src/backend/utils/cache/relcache.c	2002/05/22 15:57:40	1.164
--- src/backend/utils/cache/relcache.c	2002/06/15 16:39:09
***************
*** 43,53 ****
  #include "catalog/pg_amproc.h"
  #include "catalog/pg_attrdef.h"
  #include "catalog/pg_attribute.h"
  #include "catalog/pg_index.h"
  #include "catalog/pg_namespace.h"
  #include "catalog/pg_opclass.h"
  #include "catalog/pg_proc.h"
- #include "catalog/pg_relcheck.h"
  #include "catalog/pg_rewrite.h"
  #include "catalog/pg_type.h"
  #include "commands/trigger.h"
--- 43,53 ----
  #include "catalog/pg_amproc.h"
  #include "catalog/pg_attrdef.h"
  #include "catalog/pg_attribute.h"
+ #include "catalog/pg_constraint.h"
  #include "catalog/pg_index.h"
  #include "catalog/pg_namespace.h"
  #include "catalog/pg_opclass.h"
  #include "catalog/pg_proc.h"
  #include "catalog/pg_rewrite.h"
  #include "catalog/pg_type.h"
  #include "commands/trigger.h"
***************
*** 296,302 ****
  static Relation RelationBuildDesc(RelationBuildDescInfo buildinfo,
  				  Relation oldrelation);
  static void AttrDefaultFetch(Relation relation);
! static void RelCheckFetch(Relation relation);
  static List *insert_ordered_oid(List *list, Oid datum);
  static void IndexSupportInitialize(Form_pg_index iform,
  								   IndexStrategy indexStrategy,
--- 296,302 ----
  static Relation RelationBuildDesc(RelationBuildDescInfo buildinfo,
  				  Relation oldrelation);
  static void AttrDefaultFetch(Relation relation);
! static void CheckConstraintFetch(Relation relation);
  static List *insert_ordered_oid(List *list, Oid datum);
  static void IndexSupportInitialize(Form_pg_index iform,
  								   IndexStrategy indexStrategy,
***************
*** 451,457 ****
   *		RelationBuildTupleDesc
   *
   *		Form the relation's tuple descriptor from information in
!  *		the pg_attribute, pg_attrdef & pg_relcheck system catalogs.
   */
  static void
  RelationBuildTupleDesc(RelationBuildDescInfo buildinfo,
--- 451,457 ----
   *		RelationBuildTupleDesc
   *
   *		Form the relation's tuple descriptor from information in
!  *		the pg_attribute, pg_attrdef & pg_constraint system catalogs.
   */
  static void
  RelationBuildTupleDesc(RelationBuildDescInfo buildinfo,
***************
*** 603,609 ****
  				MemoryContextAlloc(CacheMemoryContext,
  								constr->num_check * sizeof(ConstrCheck));
  			MemSet(constr->check, 0, constr->num_check * sizeof(ConstrCheck));
! 			RelCheckFetch(relation);
  		}
  		else
  			constr->num_check = 0;
--- 603,609 ----
  				MemoryContextAlloc(CacheMemoryContext,
  								constr->num_check * sizeof(ConstrCheck));
  			MemSet(constr->check, 0, constr->num_check * sizeof(ConstrCheck));
! 			CheckConstraintFetch(relation);
  		}
  		else
  			constr->num_check = 0;
***************
*** 2483,2533 ****
  }
  
  static void
! RelCheckFetch(Relation relation)
  {
  	ConstrCheck *check = relation->rd_att->constr->check;
  	int			ncheck = relation->rd_att->constr->num_check;
  	Relation	rcrel;
  	SysScanDesc rcscan;
! 	ScanKeyData skey;
  	HeapTuple	htup;
- 	Name		rcname;
  	Datum		val;
  	bool		isnull;
  	int			found;
  
! 	ScanKeyEntryInitialize(&skey,
! 						   (bits16) 0x0,
! 						   (AttrNumber) Anum_pg_relcheck_rcrelid,
! 						   (RegProcedure) F_OIDEQ,
  						   ObjectIdGetDatum(RelationGetRelid(relation)));
  
! 	rcrel = heap_openr(RelCheckRelationName, AccessShareLock);
! 	rcscan = systable_beginscan(rcrel, RelCheckIndex, true,
! 								SnapshotNow,
! 								1, &skey);
! 	found = 0;
  
  	while (HeapTupleIsValid(htup = systable_getnext(rcscan)))
  	{
  		if (found == ncheck)
! 			elog(ERROR, "RelCheckFetch: unexpected record found for rel %s",
  				 RelationGetRelationName(relation));
  
- 		rcname = (Name) fastgetattr(htup,
- 									Anum_pg_relcheck_rcname,
- 									rcrel->rd_att, &isnull);
- 		if (isnull)
- 			elog(ERROR, "RelCheckFetch: rcname IS NULL for rel %s",
- 				 RelationGetRelationName(relation));
  		check[found].ccname = MemoryContextStrdup(CacheMemoryContext,
! 												  NameStr(*rcname));
  		val = fastgetattr(htup,
! 						  Anum_pg_relcheck_rcbin,
  						  rcrel->rd_att, &isnull);
  		if (isnull)
! 			elog(ERROR, "RelCheckFetch: rcbin IS NULL for rel %s",
  				 RelationGetRelationName(relation));
  		check[found].ccbin = MemoryContextStrdup(CacheMemoryContext,
  							 DatumGetCString(DirectFunctionCall1(textout,
  																 val)));
--- 2483,2531 ----
  }
  
  static void
! CheckConstraintFetch(Relation relation)
  {
  	ConstrCheck *check = relation->rd_att->constr->check;
  	int			ncheck = relation->rd_att->constr->num_check;
  	Relation	rcrel;
  	SysScanDesc rcscan;
! 	ScanKeyData skey[2];
! 	int			skeyCount = 0;
  	HeapTuple	htup;
  	Datum		val;
  	bool		isnull;
  	int			found;
  
! 	ScanKeyEntryInitialize(&skey[skeyCount++],
! 						   0, Anum_pg_constraint_conrelid, F_OIDEQ,
  						   ObjectIdGetDatum(RelationGetRelid(relation)));
  
! 	rcrel = heap_openr(ConstraintRelationName, AccessShareLock);
! 	rcscan = systable_beginscan(rcrel, ConstraintRelidNameIndex, true,
! 								SnapshotNow, skeyCount, skey);
  
+ 	found = 0;
  	while (HeapTupleIsValid(htup = systable_getnext(rcscan)))
  	{
+ 		/* Check constraints only */
+ 		if (CONSTRAINT_CHECK != ((Form_pg_constraint) GETSTRUCT(htup))->contype)
+ 			continue;
+ 
  		if (found == ncheck)
! 			elog(ERROR, "CheckConstraintFetch: unexpected record found for rel %s",
  				 RelationGetRelationName(relation));
  
  		check[found].ccname = MemoryContextStrdup(CacheMemoryContext,
! 								NameStr(((Form_pg_constraint) GETSTRUCT(htup))->conname));
! 
! 		/* Grab and test conbin is actually set */
  		val = fastgetattr(htup,
! 						  Anum_pg_constraint_conbin,
  						  rcrel->rd_att, &isnull);
  		if (isnull)
! 			elog(ERROR, "CheckConstraintFetch: conbin IS NULL for rel %s",
  				 RelationGetRelationName(relation));
+ 
  		check[found].ccbin = MemoryContextStrdup(CacheMemoryContext,
  							 DatumGetCString(DirectFunctionCall1(textout,
  																 val)));
***************
*** 2538,2544 ****
  	heap_close(rcrel, AccessShareLock);
  
  	if (found != ncheck)
! 		elog(ERROR, "RelCheckFetch: %d record(s) not found for rel %s",
  			 ncheck - found, RelationGetRelationName(relation));
  }
  
--- 2536,2542 ----
  	heap_close(rcrel, AccessShareLock);
  
  	if (found != ncheck)
! 		elog(ERROR, "CheckConstraintFetch: %d record(s) not found for rel %s",
  			 ncheck - found, RelationGetRelationName(relation));
  }
  
Index: src/bin/initdb/initdb.sh
===================================================================
RCS file: /projects/cvsroot/pgsql/src/bin/initdb/initdb.sh,v
retrieving revision 1.155
diff -c -r1.155 initdb.sh
*** src/bin/initdb/initdb.sh	2002/05/21 19:06:00	1.155
--- src/bin/initdb/initdb.sh	2002/06/15 16:39:10
***************
*** 682,692 ****
  
  "$PGPATH"/postgres $PGSQL_OPT template1 >/dev/null <<EOF
  ALTER TABLE pg_attrdef CREATE TOAST TABLE;
  ALTER TABLE pg_database CREATE TOAST TABLE;
  ALTER TABLE pg_description CREATE TOAST TABLE;
  ALTER TABLE pg_group CREATE TOAST TABLE;
  ALTER TABLE pg_proc CREATE TOAST TABLE;
- ALTER TABLE pg_relcheck CREATE TOAST TABLE;
  ALTER TABLE pg_rewrite CREATE TOAST TABLE;
  ALTER TABLE pg_shadow CREATE TOAST TABLE;
  ALTER TABLE pg_statistic CREATE TOAST TABLE;
--- 682,692 ----
  
  "$PGPATH"/postgres $PGSQL_OPT template1 >/dev/null <<EOF
  ALTER TABLE pg_attrdef CREATE TOAST TABLE;
+ ALTER TABLE pg_constraint CREATE TOAST TABLE;
  ALTER TABLE pg_database CREATE TOAST TABLE;
  ALTER TABLE pg_description CREATE TOAST TABLE;
  ALTER TABLE pg_group CREATE TOAST TABLE;
  ALTER TABLE pg_proc CREATE TOAST TABLE;
  ALTER TABLE pg_rewrite CREATE TOAST TABLE;
  ALTER TABLE pg_shadow CREATE TOAST TABLE;
  ALTER TABLE pg_statistic CREATE TOAST TABLE;
